var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key2, value) => key2 in obj ? __defProp(obj, key2, { enumerable: true, configurable: true, writable: true, value }) : obj[key2] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key2 of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key2) && key2 !== except)
        __defProp(to, key2, { get: () => from[key2], enumerable: !(desc = __getOwnPropDesc(from, key2)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  DEFAULT_AUTH_COOKIE_NAME: () => DEFAULT_AUTH_COOKIE_NAME,
  default: () => src_default,
  getProps: () => getProps,
  resolveAuthCookieName: () => resolveAuthCookieName
});
module.exports = __toCommonJS(src_exports);
var import_hypercontroller = require("@hyperstackjs/hypercontroller");
var import_hyperstack = require("hyperstack");
var import_debug = __toESM(require("debug"));
var debug = (0, import_debug.default)("hyperstack:init-jwt");
var DEFAULT_AUTH_COOKIE_NAME = "HS_AUTH";
var key = "jwt";
var getProps = () => import_hyperstack.context.initializerProps(key);
var resolveAuthCookieName = (cookieNameConfig) => {
  if (!cookieNameConfig) {
    return null;
  }
  if (cookieNameConfig === true) {
    return DEFAULT_AUTH_COOKIE_NAME;
  } else if (typeof cookieNameConfig == "string" && cookieNameConfig.length > 0) {
    return cookieNameConfig;
  } else {
    return null;
  }
};
var src_default = (createLoader) => async (context2) => {
  const loader = createLoader(context2);
  const config = context2.config();
  const jwtSecretOrPublicKey = config.controllers.jwtSecret;
  if (!jwtSecretOrPublicKey) {
    throw new Error("No JWT secret is set in configuration");
  }
  const bearer = config.controllers.bearer || void 0;
  const resolvedAuthCookieName = resolveAuthCookieName(config.controllers.authCookieName);
  let finalParams;
  const baseParams = {
    secret: jwtSecretOrPublicKey,
    loader,
    bearer,
    jwtOptions: {
      expiresIn: config.controllers.jwtExpiry || "14d",
      algorithm: config.controllers.jwtAlgorithm || "HS512"
    }
  };
  if (resolvedAuthCookieName) {
    finalParams = __spreadProps(__spreadValues({}, baseParams), {
      authCookieName: resolvedAuthCookieName
    });
  } else {
    finalParams = __spreadValues({}, baseParams);
  }
  const { MustAuthWithJWT, MustAuthRouteWithJWT, signJWT, verifyJWT } = (0, import_hypercontroller.authWithJWT)(finalParams);
  return {
    provideProps() {
      return {
        [key]: {
          MustAuthWithJWT,
          MustAuthRouteWithJWT,
          signJWT,
          verifyJWT,
          currentUser(req) {
            if (!req.user) {
              debug("no user in request");
              throw (0, import_hypercontroller.err)("no user");
            }
            return req.user;
          }
        }
      };
    }
  };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  DEFAULT_AUTH_COOKIE_NAME,
  getProps,
  resolveAuthCookieName
});
